using System;
using System.Text;
using System.Runtime.InteropServices;

	/// <summary>
	/// Summary description for LepCom.
	/// </summary>
public class LEP
{[StructLayout(LayoutKind.Sequential, Pack=1)] 
    public struct LEPBinMsg
    {
        public byte hash;   // Bits from MSGTYPE_*
        public byte id;
        public byte cmd;
        public byte index0;
        public byte index1;
        public long data;
        public byte ending;
    }
	///////////////////////////////////////////////////////////////////////////////
	//  LepComStop()
	//  
	[DllImport("lepcom.dll", EntryPoint="LepComStop")]
	public static extern int LepComStop(int module);

	///////////////////////////////////////////////////////////////////////////////
	//  LepComShowSetup()
	//  
	[DllImport("lepcom.dll", EntryPoint="LepComShowSetup")]
	public static extern int LepComShowSetup();
	///////////////////////////////////////////////////////////////////////////////
	//  LepComDebug()
	//  
	[DllImport("lepcom.dll", EntryPoint="LepComDebug")]
	public static extern int LepComDebug(uint mode);// 0 disable   2 - decimal
    ///////////////////////////////////////////////////////////////////////////////
    //  LepComDisplay()
    //  
    [DllImport("lepcom.dll", EntryPoint = "LepComDisplay")]
    public static extern void LepComDisplay(int mode);// 0 disable  1=ascii,2=dec,3=hex

	// 1 ascii     4 - hex??
	///////////////////////////////////////////////////////////////////////////////
	//  LepGetRxLength()
	//  
	[DllImport("lepcom.dll", EntryPoint="LepGetRxLength")]
	public static extern int LepGetRxLength(uint mode);
	///////////////////////////////////////////////////////////////////////////////
	//  LepComOpen()
	//  opens communication port
	//
	//
	[DllImport("lepcom.dll", EntryPoint="LepComOpen")]
	public static extern int LepComOpen();
	///////////////////////////////////////////////////////////////////////////////
	//  LepComClose()
	//  Closes communication port
	//
	//
	[DllImport("lepcom.dll", EntryPoint="LepComClose")]
	public static extern int LepComClose();
	///////////////////////////////////////////////////////////////////////////////
	//  LepComSetPosition()
	//  Writes Position to Module
	//
	//
	[DllImport("lepcom.dll", EntryPoint="LepComSetPosition")]
	public static extern int LepComSetPosition(int module,int position);
	///////////////////////////////////////////////////////////////////////////////
	//  LepComGetPosition()
	//  Gets Position from Module
	//
	//
	[DllImport("lepcom.dll", EntryPoint="LepComGetPosition")]
	public static extern int LepComGetPosition(int module);
	///////////////////////////////////////////////////////////////////////////////
	//  LepComGetMotorStatus(u32 module)
	//  Gets motor status from Module
	//
	//
	[DllImport("lepcom.dll", EntryPoint="LepComGetMotorStatus")]
	public static extern int LepComGetMotorStatus(int module);
	///////////////////////////////////////////////////////////////////////////////
	//  LepComSetTarget()
	//  Writes Target value to module
	//
	//
	[DllImport("lepcom.dll", EntryPoint="LepComSetTarget")]
	public static extern int LepComSetTarget(int module,int target);
	///////////////////////////////////////////////////////////////////////////////
	//  LepComWrite()
	//  Writes communication port
	//
	//
	//[DllImport("lepcom.dll", EntryPoint="LepComWrite")]
	//public static extern int LepComWrite(StringBuilder str,int len);
    [DllImport("lepcom.dll", EntryPoint = "LepComWrite")]
    public static extern int LepComWrite(StringBuilder str, int len);
	///////////////////////////////////////////////////////////////////////////////
	//  LepComRead()
	//  Reads communication port
	//
	//
	[DllImport("lepcom.dll", EntryPoint="LepComRead")]
    public static extern int LepComRead(out LEPBinMsg serMsg, int len);
	///////////////////////////////////////////////////////////////////////////////
	//  LepComReadString()
	//  Reads communication port and adds a null at the end
	//
	//
	[DllImport("lepcom.dll", EntryPoint="LepComReadString")]
	public static extern int LepComReadString(StringBuilder str,int len);
	///////////////////////////////////////////////////////////////////////////////
	//  LepComDumpRx()
	//  Clears rx data in buffer
	//
	//
	[DllImport("lepcom.dll", EntryPoint="LepComDumpRx")]
	public static extern void LepComDumpRx();
	///////////////////////////////////////////////////////////////////////////////
	//  LepComWait4LF()
	//  Wait4LF communication port
	//
	//
	[DllImport("lepcom.dll", EntryPoint="LepComWait4LF")]
	public static extern int LepComWait4LF(uint len);
	///////////////////////////////////////////////////////////////////////////////
	//  LepComGetRxLen(u8 Mode)
	//  returns the length of data in the rx'd buffer - mode 0 returns data currently in
	//									mode 10(decimal for LF)rtns len of data includg LF
	//
	[DllImport("lepcom.dll", EntryPoint="LepComGetRxLen")]
	public static extern int LepComGetRxLen(byte mode);
	///////////////////////////////////////////////////////////////////////////////
	//  LepComGetIds(CString *cstr)
	//  returns the length of data in the rx'd buffer - mode 0 returns data currently in
	//									mode 10(decimal for LF)rtns len of data includg LF
	//
	[DllImport("lepcom.dll", EntryPoint="LepComGetIds")]
	public static extern void LepComGetIds(out string cstr);
	///////////////////////////////////////////////////////////////////////////////
	//  int LepComWriteByte(int Module, int Command, int value)
	//  write byte command with one byte data to module
	//
	[DllImport("lepcom.dll", EntryPoint="LepComWriteByte")]
	public static extern int LepComWriteByte(int Module, int Command, int value);
	///////////////////////////////////////////////////////////////////////////////
	//  int LepComWrite3Byte(int Module, int Command, int value)
	//  write byte command with one byte data to module
	//
	///////////////////////////////////////////////////////////////////////////////
	[DllImport("lepcom.dll", EntryPoint="LepComWrite3Byte")]
	public static extern int LepComWrite3Byte(int Module, int Command, int value);
	///////////////////////////////////////////////////////////////////////////////
	//  int LepComWriteWord(int Module, int Command, int value)
	//  write byte command with Word data to module
	//
	[DllImport("lepcom.dll", EntryPoint="LepComWriteWord")]
	public static extern int LepComWriteWord(int Module, int Command, int value);
	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	//  int LepComWriteDWord(int Module, int Command, int value)
	//  write byte command with DWord data to module
	//
	[DllImport("lepcom.dll", EntryPoint="LepComWriteDWord")]
	public static extern int LepComWriteDWord(int Module, int Command, int value);
	///////////////////////////////////////////////////////////////////////////////
	//  int LepComReadByte(int Module, int Command)
	//  read byte command with one byte data returned
	//
	[DllImport("lepcom.dll", EntryPoint="LepComReadByte")]
	public static extern int LepComReadByte(int Module, int Command);
	///////////////////////////////////////////////////////////////////////////////
	//  int LepComRead3Byte(int Module, int Command)
	//  read byte command with one byte data returned
	//
	[DllImport("lepcom.dll", EntryPoint="LepComRead3Byte")]
	public static extern int LepComRead3Byte(int Module, int Command);
	///////////////////////////////////////////////////////////////////////////////
	//  void LepComUserMessage(string str)
	//  writes a user character string to transaction window
	//
	[DllImport("lepcom.dll", EntryPoint="LepComUserMessage")]
	public static extern void LepComUserMessage(StringBuilder str);
	///////////////////////////////////////////////////////////////////////////////
	//  float LepComGetDLLVersion()
	//  returns version of dll
	//
	[DllImport("lepcom.dll", EntryPoint="LepComGetDLLVersion")]
	public static extern float LepComGetDLLVersion();
	
	///////////////////////////////////////////////////////////////////////////////
	//  void LepComIsModulePresent()
	//  returns 0 if not preseent else version * 10
	//  recan positive forces relooking at all modules
	[DllImport("lepcom.dll", EntryPoint="LepComIsModulePresent")]
	public static extern int LepComIsModulePresent(int module,int rescan);
	///////////////////////////////////////////////////////////////////////////////
	//  void LepComGet1Wire()
	//  0 on Success, Non-Zero on error
	//  device is which 1wire range 1-4
	// The buffer is 40 bytes and must be allocated before calling this function.
	[DllImport("lepcom.dll", EntryPoint="LepComGet1Wire")]
	public static extern int LepComGet1Wire(int module,int device, StringBuilder str);
     ///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	//  S32 LepComSendCAN(U32 Module, U32 CmdNum, U32 Index, U32 Data) 
	//  Setups a CAN message and send it to a device. Return zero on success.
	//
	[DllImport("lepcom.dll", EntryPoint="LepComSendCAN")]
	public static extern int LepComSendCAN(uint module, uint cmd,uint index,int data);	
	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	//  S32 LepComWait4CAN(U32 Module, U32 CmdNum, U32 *IndexOut, U32 Data) 
	// Waits for a received CAN message whos Module and CmdNum match. Return 
    // zero on success and nonzero of timeout or non-match error. 
	//
	[DllImport("lepcom.dll", EntryPoint="LepComWait4CAN")]
	public static extern uint LepComWait4CAN(uint module, uint cmd,out uint index,out int dataout);	
	
    ///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	//  S32 LepComSetIndex(U32 Module, U32 CmdNum, U32 Data) 
	//  Sets a CAN index data value. Return zero on success.
	//
	[DllImport("lepcom.dll", EntryPoint="LepComSetIndex")]
	public static extern int LepComSetIndex(uint module, uint index,int dataout);	
	
    ///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	//  S32 LepComGetIndex(U32 Module, U32 CmdNum, U32 Data) 
	//  Gets a CAN index data value. Return zero on success.
	//
	[DllImport("lepcom.dll", EntryPoint="LepComGetIndex")]
	public static extern int LepComGetIndex(uint module, uint index,out int dataout);	
	
	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	//  int LepComUserMessage(U8* string) 
	//  Writes a user character string to the transaction window
	//
	[DllImport("lepcom.dll", EntryPoint="LepComUserMessage")]
	public static extern void LepComUserMessage(out string cstr);	
	
   
//MAC6000 Reports

///////////////////////////////////////////////////////////////////////////////
// Gets an asynchronous report from Module and ReportType passed (see MAC6000 command 
// manual for report types). Returns a negative number if the report never existed, returns 
// zero is the report is new and has never been read and returns 1 if the report present but has been read before. 
// If mode is 1 the report is deleted. If mode is zero the report is mark read if it was present.
// The IndexOut and DataOut are the index and data of the report. TimeOut is the age of the report in milliseconds.
[DllImport("lepcom.dll", EntryPoint="LepComGetReport")]
public static extern int LepComGetReport(uint Module, uint ReportType, uint Mode, out uint IndexOut, out uint DataOut, out uint TimeOut);



///////////////////////////////////////////////////////////////////////////////
//Configures the DLL to send Windows Messages to the users application. When enabled 
//the DLL will send asynchronous MAC6000 Reports to the users application via the 
//Windows Messaging system. This allows the user application to be event driven from the 
//LEP hardware. For LEP report description see the MAC6000 command manual. The LEP Reports
//must be enabled by the user. The hWnd parameter must be set to the windows handle of 
//your application. The WMCode is the Windows Message base code number, this number must be 
//above 0x0400 or WM_USER. WMCode below 0x0400 are reserved for Windows. Recommend value 
//is 0x8000. Once enabled your application will receive these Windows Message on any LEP 
//Report. The Window Message code will be equal to the LEP Report Number plus the WMCode 
//passed when setting up this command up. The wParam will be set to the report index and 
//the lParam will be set to the report data.
[DllImport("lepcom.dll", EntryPoint="LepComReportRegister")]
public static extern int LepComReportRegister(uint hWnd, uint WMCode );


///////////////////////////////////////////////////////////////////////////////
//Un-configures the DLL to send Windows Messages to the users application. This should be 
//called when your program does not want LEP Report sent via the Windows Message system. Cancels the above command.
    [DllImport("lepcom.dll", EntryPoint = "LepComReportUnRegister")]
    public static extern int LepComReportUnRegister(uint hWnd); 
}

