// LepCom DLL simple Example
using System;
using System.Text;						// for StringBuilder
using System.Runtime.InteropServices;	// DLL Import

public class LEP
{
	[DllImport("LepCom.Dll")] public static extern int LepComShowSetup();
	[DllImport("LepCom.Dll")] public static extern void LepComDumpRx();
	[DllImport("LepCom.Dll")] public static extern int LepComOpen();
	[DllImport("LepCom.Dll")] public static extern int LepComClose();
	[DllImport("LepCom.Dll")] public static extern int LepComWrite(StringBuilder str,   uint len);
	[DllImport("LepCom.Dll")] public static extern int LepComRead(StringBuilder buffer, uint size);
	[DllImport("LepCom.Dll")] public static extern int LepComWait4LF(uint TimeOut);
}

namespace LepComCS
{
	class Class1
	{
		static void Main(string[] args)
		{
		StringBuilder str = new StringBuilder(1024);			// You must must predefined string with the DLL
		System.Console.WriteLine("LepCom DLL Simple C# example.");	// Print title

		LEP.LepComShowSetup();						// Open the setup dialog, comment out if not wanted
		int status = LEP.LepComOpen();					// Open the LEP device
		if(status > 0)									// If openned
			{
			str.Insert(0,"ver\r");						// Setup the command string
			LEP.LepComWrite(str, (uint)str.Length);		// Send the command to the LEP device
			uint size = (uint)LEP.LepComWait4LF(2000);	// Wait for LF
			LEP.LepComRead(str, size);					// Read the received data
			System.Console.WriteLine(str);				// Print the recevice data
			LEP.LepComClose();							// Close the Lep device
			}
		else
			System.Console.WriteLine("Unable to open LEP device.");

		System.Console.WriteLine("Press Enter to Continue");
		System.Console.Read();
		}
	}
}
