Imports System.Text 'required for StringBuilder

Module Module1
    Private Declare Function LepComShowSetup Lib "LEPCOM.DLL" () As Long
    Private Declare Function LepComOpen Lib "LEPCOM.DLL" () As Long
    Private Declare Function LepComClose Lib "LEPCOM.DLL" () As Long
    Private Declare Function LepComWrite Lib "LEPCOM.DLL" (ByVal str As StringBuilder, ByVal size As Long) As Long
    Private Declare Function LepComWriteString Lib "LEPCOM.DLL" (ByVal str As StringBuilder) As Long
    Private Declare Function LepComRead Lib "LEPCOM.DLL" (ByVal str As StringBuilder, ByVal size As Long) As Long
    Private Declare Function LepComReadString Lib "LEPCOM.DLL" (ByVal str As StringBuilder, ByVal size As Long) As Long
    Private Declare Function LepComGetRxLen Lib "LEPCOM.DLL" (ByVal mode As Long) As Long
    Private Declare Function LepComWait4LF Lib "LEPCOM.DLL" (ByVal TimeOut As Long) As Long


    Sub Main()
        System.Console.WriteLine("LepCom DLL Simpe VB.net Example")
        Dim buffer As New StringBuilder(1024)
        Dim status, size As Long

        LepComShowSetup()               ' Show the setup dialog
        status = LepComOpen()           ' Open the LEP device
        If 0 Then
            buffer.Insert(0, "ver")             ' Setup the command
            buffer.Append(Chr(13))              ' Add the CR
            status = LepComWrite(buffer, buffer.Length) ' Send the Command, 4 bytes long
            status = LepComWait4LF(2000)        ' Wait for the LineFeed, wait up to 2seconds
            size = LepComGetRxLen(0)            ' Get the Rx length
            status = LepComReadString(buffer, size) ' read the Rx String
            status = LepComClose()                  ' Close the device
            System.Console.WriteLine(buffer)        ' print the results

        Else
            System.Console.WriteLine("Unable to open LEP device.")
        End If

        System.Console.WriteLine("Press Enter to Continue")
        System.Console.Read()


    End Sub

End Module
