/////////////////////////////////////////////////////////////////////////////
// LEPCOM DLL HEADER FILE
// To use the LEPCOM DLL is a C project:
// 1 - Copy the LEPCOM.H and LEPCOM.LIB file to the source code directory
// 2 - Copy the LEPCOM.DLL file to the run directory ( Release or Debug directory)
// 3 - Add the LEPCOM.LIB file to the project ( usally in thre linker settings)
// 4 - Add the #include "LEPCOM.H" to your C file and call the LEPCOM functions.


#ifndef LEPCOMDLL_HEADER_FILE
#define LEPCOMDLL_HEADER_FILE


// -------------------------------------------- //
// Data Structures
// -------------------------------------------- //
#if 0
typedef struct _LepComStruct {
	BYTE Type;		// 0=uninitialized, 1 = RS232, 2=USB, 3=TCPIP
	BYTE RS232Port;
	
	BYTE Baud;		// by index	
	BYTE Parity;
	BYTE StopBits;
	BYTE FlowCtrl;
	BYTE DeviceNum;
	
	BYTE USBPort;

	DWORD IPAddress;
	DWORD IPPort;
	
	int	 RxSize;
	int	 RxTimeOut;
	int	 TxTimeOut;

	DWORD Verbose;
	DWORD DebugWindow;

	DWORD UpdateTimer; 
	DWORD AutoDetect;
	DWORD SysTrayIcon;

} LepComStruct, *pLepComStruct;
#endif
// -------------------------------------------- //
// Common Functions
// -------------------------------------------- //



double __stdcall LepComGetDLLVersion();
int __stdcall LepComOpen(void);
//int __stdcall LepComOpenEx(pLepComStruct pComStruct, int Mode);
int __stdcall LepComClose();
int __stdcall LepComShowSetup();
int __stdcall LepComWriteString(char* str);
int __stdcall LepComWrite(char* str, unsigned int len);
int __stdcall LepComReadString(char* buffer, unsigned int size);
int __stdcall LepComRead(char* buffer, unsigned int size);
int __stdcall LepComGetRxLen(unsigned int Mode);
int __stdcall LepComWait4LF(unsigned int TimeOut);
int __stdcall LepComIsOpen(void);
void __stdcall LepComDumpRx(void);
void __stdcall LepComDebug(int Mode);
int __stdcall LepComUserMessage(char* user_msg);
int __stdcall LepComSetupWrapperMode(int Mode);
int __stdcall LepComGetReport(int ModuleId, int Type, int Mode, int *IndexOut, int *DataOut, int *TimeOut);
int __stdcall LepComShowDownLoad();
int __stdcall LepComShowDRO();
int __stdcall LepComReportRegister( HWND hWnd, UINT UserCode);
int __stdcall LepComReportUnRegister( HWND hWnd);

int __stdcall LepComWriteM6(int IndexNum, int CmdLength, char* ptr);			
int __stdcall LepComReadM6( int IndexNum, int CmdLength, int Terminate, char* ptr);			
int __stdcall LepComWait4M6(int IndexNum );


// CAN Functions - Only available on MAC6000 products
int __stdcall LepComWait4CAN(int ModuleId, int CmdNum,   int *IndexOut, int *DataOut );
int __stdcall LepComSendCAN( int ModuleId, int CmdNum,   int IndexNum,  int Data);
int __stdcall LepComSetIndex(int ModuleId, int IndexNum, int Data);
int __stdcall LepComGetIndex(int ModuleId, int IndexNum, int *DataOut);


// -------------------------------------------- //
// Extended Commands
// -------------------------------------------- //

int __stdcall LepComGet1Wire(int Module, int Device, char* pOneWire);
int __stdcall LepComSet1Wire(int Module, int Device, char* pOneWire);
int __stdcall LepComSetAccel(int Module, int Accel);		// UNITS GARBIS
int __stdcall LepComSetAcc(int Module, int Accel);		// UNITS PPS2
int __stdcall LepComGetAccel(int Module );			// UNITS GARBIS
int __stdcall LepComGetAcc(int Module );			// UNITS PPS2
int __stdcall LepComSetVelocity(int Module, int Velocity);
int __stdcall LepComGetVelocity(int Module );
int __stdcall LepComSetPosition(int Module, int Position);
int __stdcall LepComGetPosition(int Module );
int __stdcall LepComGetIds(CString* Ids);
int __stdcall LepComInterfaceVersion(void);
int __stdcall LepComIsModulePresent(int Module, int Rescan);
int __stdcall LepComGetModuleStatus(int module);
int __stdcall LepComGetMotorStatus(int module);
int __stdcall LepComSetTarget(int Module, int Target);
int __stdcall LepComGetTarget(int Target );
int __stdcall LepComGoto(int Module, int Target );
int __stdcall LepComStop(int Module );
int __stdcall LepComIsBusy(int Module );




int __stdcall LepComWriteRaw(int Module, int Command, int size, int value );
int __stdcall LepComWriteCommand(int Module, int Command);
int __stdcall LepComWriteByte(int Module, int Command, int value );
int __stdcall LepComWrite3Byte(int Module, int Command, int value );
int __stdcall LepComWriteWord(int Module, int Command, int value );
int __stdcall LepComWriteDWord(int Module, int Command, int value );

int __stdcall LepComReadRaw(int Module, int Command, int Size );
int __stdcall LepComReadByte(int Module, int Command );
int __stdcall LepComRead3Byte(int Module, int Command );
int __stdcall LepComReadWord(int Module, int Command );
int __stdcall LepComReadDWord(int Module, int Command );

int __stdcall LepComShowUpLoad();


#endif